/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * Activity
 */

public class Activity {
  @JsonProperty("actor")
  private Object actor = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("icon")
  private String icon = null;

  @JsonProperty("key")
  private String key = null;

  @JsonProperty("kwargs")
  private Object kwargs = null;

  @JsonProperty("label")
  private String label = null;

  @JsonProperty("organization")
  private Object organization = null;

  @JsonProperty("related_to")
  private String relatedTo = null;

  @JsonProperty("related_to_id")
  private String relatedToId = null;

  @JsonProperty("related_to_kind")
  private String relatedToKind = null;

  @JsonProperty("related_to_url")
  private String relatedToUrl = null;

  public Activity actor(Object actor) {
    this.actor = actor;
    return this;
  }

   /**
   * The user who performed the action
   * @return actor
  **/
  @ApiModelProperty(value = "The user who performed the action")
  public Object getActor() {
    return actor;
  }

  public void setActor(Object actor) {
    this.actor = actor;
  }

   /**
   * When the action has been performed
   * @return createdAt
  **/
  @ApiModelProperty(value = "When the action has been performed")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public Activity icon(String icon) {
    this.icon = icon;
    return this;
  }

   /**
   * The icon of the activity
   * @return icon
  **/
  @ApiModelProperty(required = true, value = "The icon of the activity")
  public String getIcon() {
    return icon;
  }

  public void setIcon(String icon) {
    this.icon = icon;
  }

  public Activity key(String key) {
    this.key = key;
    return this;
  }

   /**
   * The key of the activity
   * @return key
  **/
  @ApiModelProperty(required = true, value = "The key of the activity")
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  public Activity kwargs(Object kwargs) {
    this.kwargs = kwargs;
    return this;
  }

   /**
   * Some action specific context
   * @return kwargs
  **/
  @ApiModelProperty(value = "Some action specific context")
  public Object getKwargs() {
    return kwargs;
  }

  public void setKwargs(Object kwargs) {
    this.kwargs = kwargs;
  }

  public Activity label(String label) {
    this.label = label;
    return this;
  }

   /**
   * The label of the activity
   * @return label
  **/
  @ApiModelProperty(required = true, value = "The label of the activity")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }

  public Activity organization(Object organization) {
    this.organization = organization;
    return this;
  }

   /**
   * The organization who performed the action
   * @return organization
  **/
  @ApiModelProperty(value = "The organization who performed the action")
  public Object getOrganization() {
    return organization;
  }

  public void setOrganization(Object organization) {
    this.organization = organization;
  }

  public Activity relatedTo(String relatedTo) {
    this.relatedTo = relatedTo;
    return this;
  }

   /**
   * The activity target name
   * @return relatedTo
  **/
  @ApiModelProperty(required = true, value = "The activity target name")
  public String getRelatedTo() {
    return relatedTo;
  }

  public void setRelatedTo(String relatedTo) {
    this.relatedTo = relatedTo;
  }

  public Activity relatedToId(String relatedToId) {
    this.relatedToId = relatedToId;
    return this;
  }

   /**
   * The activity target object identifier
   * @return relatedToId
  **/
  @ApiModelProperty(required = true, value = "The activity target object identifier")
  public String getRelatedToId() {
    return relatedToId;
  }

  public void setRelatedToId(String relatedToId) {
    this.relatedToId = relatedToId;
  }

  public Activity relatedToKind(String relatedToKind) {
    this.relatedToKind = relatedToKind;
    return this;
  }

   /**
   * The activity target object class name
   * @return relatedToKind
  **/
  @ApiModelProperty(required = true, value = "The activity target object class name")
  public String getRelatedToKind() {
    return relatedToKind;
  }

  public void setRelatedToKind(String relatedToKind) {
    this.relatedToKind = relatedToKind;
  }

  public Activity relatedToUrl(String relatedToUrl) {
    this.relatedToUrl = relatedToUrl;
    return this;
  }

   /**
   * The activity target model
   * @return relatedToUrl
  **/
  @ApiModelProperty(required = true, value = "The activity target model")
  public String getRelatedToUrl() {
    return relatedToUrl;
  }

  public void setRelatedToUrl(String relatedToUrl) {
    this.relatedToUrl = relatedToUrl;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Activity activity = (Activity) o;
    return Objects.equals(this.actor, activity.actor) &&
        Objects.equals(this.createdAt, activity.createdAt) &&
        Objects.equals(this.icon, activity.icon) &&
        Objects.equals(this.key, activity.key) &&
        Objects.equals(this.kwargs, activity.kwargs) &&
        Objects.equals(this.label, activity.label) &&
        Objects.equals(this.organization, activity.organization) &&
        Objects.equals(this.relatedTo, activity.relatedTo) &&
        Objects.equals(this.relatedToId, activity.relatedToId) &&
        Objects.equals(this.relatedToKind, activity.relatedToKind) &&
        Objects.equals(this.relatedToUrl, activity.relatedToUrl);
  }

  @Override
  public int hashCode() {
    return Objects.hash(actor, createdAt, icon, key, kwargs, label, organization, relatedTo, relatedToId, relatedToKind, relatedToUrl);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Activity {\n");

    sb.append("    actor: ").append(toIndentedString(actor)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    icon: ").append(toIndentedString(icon)).append("\n");
    sb.append("    key: ").append(toIndentedString(key)).append("\n");
    sb.append("    kwargs: ").append(toIndentedString(kwargs)).append("\n");
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("    organization: ").append(toIndentedString(organization)).append("\n");
    sb.append("    relatedTo: ").append(toIndentedString(relatedTo)).append("\n");
    sb.append("    relatedToId: ").append(toIndentedString(relatedToId)).append("\n");
    sb.append("    relatedToKind: ").append(toIndentedString(relatedToKind)).append("\n");
    sb.append("    relatedToUrl: ").append(toIndentedString(relatedToUrl)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

